from mpython import *  #导入mpython库
from umqtt.simple import MQTTClient  #导入umqtt.simple模块中的MQTTClinet
from bluebit import *  #导入bluebit模块
import time            #导入time库
import network         #导入network模块
import music           #导入music模块
p2 = MPythonPin(2,PinMode.ANALOG)    #引脚2设置为模拟输入模式(烟雾传感器)
p14 = MPythonPin(14,PinMode.OUT)     #引脚14设置为数字输出模式(驱动器)
sht20 = SHT20()                      #实例化SHT20(温湿传感器)
my_wifi = wifi()                     #实例化wifi
my_wifi.connectWiFi('HUAWEI-040J8Q', 'xlzx8888')  #连接无线网络
while True:                          #循环
    if p2.read_analog() > 480:       #如果引脚2读取的模拟值大于480
        p14.write_digital(1)         #引脚14输出高电平，启动电机风扇
        music.pitch(131,500)         #蜂鸣器播放c1音调，500毫秒
    else:                            #否则
        p14.write_digital(0)         #引脚14输出低电平，电机风扇关闭
                                     #如何温度值大于30或者湿度值大于65
    if sht20.temperature() > 30 or sht20.humidity() > 65:
        p14.write_digital(1)         #引脚14输出高电平，启动电机风扇
    else:                            #否则
        p14.write_digital(0)         #引脚14输出低电平，电机风扇关闭
    oled.fill(0)                     #在oled屏上显示温度、湿度、烟雾深度值
    oled.DispChar('温度：'+str(sht20.temperature()),10,10)
    oled.DispChar('湿度：'+str(sht20.humidity()),10,28)
    oled.DispChar('烟雾浓度：'+str(p2.read_analog()),10,46)
    oled.show()
    #MQTT相关信息设置（客户端id，服务器地址，端口,lot_id，lot_pwd，连接检测时间间隔）
    mqtt = MQTTClient('0805e3d04f3b34e7', '182.254.130.180', 1883, 'HCuFhZlGR', 'HCXFhZlGgz', keepalive=30)
    try:  #尝试连接mqtt服务器，如果成功，输出'己连接'，否则，输出'没有连接'
        mqtt.connect()
        print('Connected')
    except:
        print('Disconnected')
    #发送烟雾浓度值到主题为'OB02hZ_MR'
    mqtt.publish('OB02hZ_MR', 'smoke_density:'+str(p2.read_analog()))
    time.sleep(10)  #延时10秒